/**
 * Relay v1.0.0-rc.4
 *
 * Copyright (c) 2013-present, Facebook, Inc.
 * All rights reserved.
 *
 * This source code is licensed under the BSD-style license found in the
 * LICENSE file in the root directory of this source tree. An additional grant
 * of patent rights can be found in the PATENTS file in the same directory.
 *
 */
module.exports=function(e){function t(i){if(n[i])return n[i].exports;var r=n[i]={exports:{},id:i,loaded:!1};return e[i].call(r.exports,r,r.exports,t),r.loaded=!0,r.exports}var n={};return t.m=e,t.c=n,t.p="",t(0)}([function(e,t,n){"use strict";e.exports=function(e){var t=e.types;return{visitor:{TaggedTemplateExpression:function(e,i){var r,a,o,s,u,l,c=n(25)(e);return c?void n(16)(t,e,i,c):(r=n(26)(e),a=r[0],o=r[1],s=r[2],void(a&&(u=i.opts&&i.opts.schema,n(3)(u,'babel-plugin-relay: Missing schema option. Check your .babelrc file or wherever you configure your Babel plugins to ensure the "relay" plugin has a "schema" option.\nhttps://facebook.github.io/relay/docs/babel-plugin-relay.html#additional-options'),l=n(23)(e,i),e.replaceWith(n(12)(t,u,a,l,s,o,i)))))}}}}},function(e,t,n){"use strict";function i(e){return e&&e.__esModule?e:{"default":e}}var r=i(n(6)),a=function o(e,t){(0,r.default)(this,o),this.message=e,this.loc=t,this.stack=(new Error).stack};e.exports=a},function(e,t){e.exports=require("util")},function(e,t,n){"use strict";function i(e,t){if(!e){for(var i=arguments.length,r=Array(i>2?i-2:0),a=2;a<i;a++)r[a-2]=arguments[a];throw new Error(n(2).format.apply(n(2),[t].concat(r)))}}e.exports=i},function(e,t){e.exports=require("graphql")},function(e,t){"use strict";function n(e,t,n){for(var i=0;i<e.length;i++)if(t.call(n,e[i],i,e))return e[i]}e.exports=n},function(e,t){e.exports=require("babel-runtime/helpers/classCallCheck")},function(e,t){"use strict";function n(e){var t,n,r=e.match(/^([a-zA-Z][a-zA-Z0-9]*)(?:_([a-zA-Z][_a-zA-Z0-9]*))?$/);if(!r)throw new Error("BabelPluginGraphQL: Fragments should be named `ModuleName_fragmentName`, got `"+e+"`.");if(t=r[1],n=r[2],n===i)throw new Error("BabelPluginGraphQL: Fragment `"+e+"` should not end in `_data` to avoid conflict with a fragment named `"+t+"` which also provides resulting data via the React prop `data`. Either rename this fragment to `"+t+"` or choose a different prop name.");return[t,n||i]}var i="data";e.exports=n},function(e,t){e.exports=require("babel-runtime/core-js/object/keys")},function(e,t,n){"use strict";var i=n(4),r=i.DirectiveLocation,a=i.GraphQLBoolean,o=i.GraphQLList,s=i.GraphQLString;e.exports={name:"relay",description:"The @relay directive.",args:{isConnectionWithoutNodeID:{description:"Marks a connection field as containing nodes without `id` fields. This is used to silence the warning when diffing connections.",type:a},pattern:{description:"Marks a fragment as intended for pattern matching (as opposed to fetching).",type:a},plural:{description:"Marks a fragment as being backed by a GraphQLList",type:a},variables:{description:"Selectively pass variables down into a fragment.",type:new o(s)}},locations:[r.FIELD,r.FRAGMENT_DEFINITION]}},function(e,t,n){"use strict";function i(e){return e&&e.__esModule?e:{"default":e}}function r(e){for(var t=!1,n=!1,i=e;;){if(i instanceof T)t=!0;else{if(!(i instanceof w))break;n=!0}i=i.ofType}return{isListType:t,isNonNullType:n,schemaUnmodifiedType:i}}function a(e){switch(e.kind){case"IntValue":return parseInt(e.value,10);case"FloatValue":return parseFloat(e.value);case"StringValue":case"BooleanValue":case"EnumValue":return e.value;case"ListValue":return e.values.map(a);case"NullValue":return null;case"ObjectValue":var t={};return e.fields.forEach(function(e){t[e.name.value]=a(e.value)}),t;case"Variable":throw new(n(1))(n(2).format("Unexpected nested variable `%s`; variables are supported as top-level arguments - `node(id: $id)` - or directly within lists - `nodes(ids: [$id])`.",e.name.value),e.loc);default:throw new(n(1))(n(2).format("Unexpected value kind: %s",e.kind),e.loc)}}var o=i(n(13)),s=i(n(30)),u=i(n(29)),l=i(n(6)),c=n(11),p=c.ID,f=n(4),d=f.GraphQLBoolean,m=f.GraphQLDirective,h=f.GraphQLEnumType,g=f.GraphQLFloat,y=f.GraphQLID,v=f.GraphQLInputObjectType,b=f.GraphQLInt,N=f.GraphQLInterfaceType,T=f.GraphQLList,w=f.GraphQLNonNull,x=f.GraphQLObjectType,L=f.GraphQLScalarType,E=f.GraphQLString,A=f.GraphQLUnionType,D=f.isAbstractType,F=f.SchemaMetaFieldDef,k=f.TypeMetaFieldDef,I=f.TypeNameMetaFieldDef,R=new m(n(9)),S=function(){function e(t,n){(0,l.default)(this,e),this.ast=n,this.context=t}return e.prototype.getLocation=function(){return this.ast.loc},e.prototype.getType=function(){n(3)(!1,"Missing Implementation")},e.prototype.getField=function(e){return n(5)(this.getFields(),function(t){return t.getName()===e})},e.prototype.getFields=function(){var e=[];return this.getSelections().forEach(function(t){t instanceof U&&e.push(t)}),e},e.prototype.getSelections=function(){var e=this;return this.ast.selectionSet?this.ast.selectionSet.selections.map(function(t){if("Field"===t.kind)return new U(e.context,t,e.getType());if("FragmentSpread"===t.kind)return new C(e.context,t);if("InlineFragment"===t.kind)return new G(e.context,t,e.getType());throw new(n(1))(n(2).format("Unexpected selection kind: %s",t.kind),e.getLocation())}):[]},e.prototype.getDirectives=function(){var e=this;return(this.ast.directives||[]).map(function(t){return new q(e.context,t)})},e.prototype.hasDirective=function(e){return(this.ast.directives||[]).some(function(t){return t.name.value===e})},e.prototype.isPattern=function(){return this.context.isPattern},e}(),_=function(e){function t(){return(0,l.default)(this,t),(0,s.default)(this,e.apply(this,arguments))}return(0,u.default)(t,e),t.prototype.getName=function(){return this.ast.name?this.ast.name.value:this.getType().getName({modifiers:!1})},t}(S),Q=function(e){function t(i,r,a){var u,c,p,f;return(0,l.default)(this,t),u={},c=n(5)(r.directives||[],function(e){return"relay"===e.name.value}),c&&(c.arguments||[]).forEach(function(e){u[e.name.value]=e.value}),p=u.pattern&&"BooleanValue"===u.pattern.kind&&u.pattern.value,f=(0,s.default)(this,e.call(this,(0,o.default)({},i,{isPattern:p}),r)),f.parentType=a,f}return(0,u.default)(t,e),t.prototype.getType=function(){var e=this.ast.typeCondition;if(e){for(;"NamedType"!==e.kind;)e=e.type;return new B(this.context,this.context.schema.getType(e.name.value))}if("InlineFragment"===this.ast.kind){if(!this.parentType)throw new(n(1))("Cannot get type of typeless inline fragment without parent type.",this.getLocation());return this.parentType}throw new(n(1))(n(2).format("Unexpected fragment kind: %s",this.ast.kind),this.getLocation())},t}(_),V=function(e){function t(){return(0,l.default)(this,t),(0,s.default)(this,e.apply(this,arguments))}return(0,u.default)(t,e),t.prototype.getType=function(){return new B(this.context,this.context.schema.getMutationType())},t}(_),P=function(e){function t(){return(0,l.default)(this,t),(0,s.default)(this,e.apply(this,arguments))}return(0,u.default)(t,e),t.prototype.getType=function(){return new B(this.context,this.context.schema.getQueryType())},t}(_),M=function(e){function t(){return(0,l.default)(this,t),(0,s.default)(this,e.apply(this,arguments))}return(0,u.default)(t,e),t.prototype.getType=function(){return new B(this.context,this.context.schema.getSubscriptionType())},t}(_),U=function(e){function t(i,r,a){var o,u,c;if((0,l.default)(this,t),o=(0,s.default)(this,e.call(this,i,r)),u=o.ast.name.value,c=a.getFieldDefinition(u,r),!c)throw new(n(1))(n(2).format("You supplied a field named `%s` on type `%s`, but no such field exists on that type.",u,a.getName({modifiers:!1})),o.getLocation());return o.fieldDef=c,o}return(0,u.default)(t,e),t.prototype.getName=function(){return this.ast.name.value},t.prototype.getAlias=function(){return this.ast.alias?this.ast.alias.value:null},t.prototype.getType=function(){return this.fieldDef.getType()},t.prototype.hasArgument=function(e){return this.getArguments().some(function(t){return t.getName()===e})},t.prototype.findArgument=function(e){return n(5)(this.getArguments(),function(t){return t.getName()===e})},t.prototype.getArguments=function(){var e=this,t=this.fieldDef.getDeclaredArguments();return(this.ast.arguments||[]).map(function(i){var r=i.name.value,a=t[r];if(!a)throw new(n(1))(n(2).format("You supplied an argument named `%s` on field `%s`, but no such argument exists on that field.",r,e.getName()),e.getLocation());return new j(e.context,i,a)})},t.prototype.hasDeclaredArgument=function(e){return this.fieldDef.getDeclaredArguments().hasOwnProperty(e)},t.prototype.getDeclaredArgument=function(e){return this.fieldDef.getArgument(e)},t.prototype.getDeclaredArguments=function(){return this.fieldDef.getDeclaredArguments()},t}(S),C=function(e){function t(){return(0,l.default)(this,t),(0,s.default)(this,e.apply(this,arguments))}return(0,u.default)(t,e),t.prototype.getName=function(){return this.ast.name.value},t.prototype.getSelections=function(){throw new(n(1))("Cannot get selection of a fragment spread.",this.getLocation())},t}(S),G=function(e){function t(n,i,r){(0,l.default)(this,t);var a=(0,s.default)(this,e.call(this,n,i));return a.parentType=r,a}return(0,u.default)(t,e),t.prototype.getFragment=function(){return new Q(this.context,this.ast,this.parentType)},t}(S),q=function(){function e(t,i){var r,a,o=this;if((0,l.default)(this,e),this.ast=i,this.context=t,this.argTypes={},r=i.name.value,a=r===n(9).name?R:t.schema.getDirective(r),!a)throw new(n(1))(n(2).format("You supplied a directive named `%s`, but no such directive exists.",r),this.getLocation());a.args.forEach(function(e){o.argTypes[e.name]=new Y(e.type)})}return e.prototype.getLocation=function(){return this.ast.loc},e.prototype.getName=function(){return this.ast.name.value},e.prototype.getArguments=function(){var e=this;return(this.ast.arguments||[]).map(function(t){var i=t.name.value,r=e.argTypes[i];if(!r)throw new(n(1))(n(2).format("You supplied an argument named `%s` on directive `%s`, but no such argument exists on that directive.",i,e.getName()),e.getLocation());return new j(e.context,t,r)})},e}(),j=function(){function e(t,n,i){(0,l.default)(this,e),this.ast=n,this.context=t,this.type=i}return e.prototype.getLocation=function(){return this.ast.loc},e.prototype.getName=function(){return this.ast.name.value},e.prototype.getType=function(){return this.type},e.prototype.isVariable=function(){return"Variable"===this.ast.value.kind},e.prototype.getVariableName=function(){if("Variable"!==this.ast.value.kind)throw new(n(1))("Cannot get variable name of an argument value.",this.getLocation());return this.ast.value.name.value},e.prototype.getValue=function(){var t,i=this;if(this.isVariable())throw new(n(1))("Cannot get value of an argument variable.",this.getLocation());return t=this.ast.value,"ListValue"===t.kind?t.values.map(function(t){return new e(i.context,(0,o.default)({},i.ast,{value:t}),i.type.ofType())}):a(t)},e}(),B=function(){function e(t,n){(0,l.default)(this,e),this.context=t;var i=r(n),a=i.isListType,o=i.isNonNullType,s=i.schemaUnmodifiedType;this.isListType=a,this.isNonNullType=o,this.schemaUnmodifiedType=s,this.schemaModifiedType=n}return e.prototype.canHaveSubselections=function(){return!(this.schemaUnmodifiedType instanceof L||this.schemaUnmodifiedType instanceof h)},e.prototype.getName=function(e){var t=e.modifiers;return t?this.schemaModifiedType.toString():this.schemaUnmodifiedType.toString()},e.prototype.hasField=function(e){return!!this.getFieldDefinition(e)},e.prototype.getFieldDefinition=function(e,t){var i,r,a,o,s=this.schemaUnmodifiedType,u=s===this.context.schema.getQueryType(),l=s instanceof x||s instanceof N||s instanceof A,c=s instanceof x||s instanceof N,p=void 0;if(u&&e===F.name?p=F:u&&e===k.name?p=k:l&&e===I.name?p=I:c&&(p=s.getFields()[e]),!p)if(l&&"__type__"===e)p={name:"__type__",type:new w(this.context.schema.getType("Type")),description:"The introspected type of this object.",deprecatedReason:"Use __typename",args:[]};else if(D(s)&&t&&t.directives&&t.directives.some(function(e){return"fixme_fat_interface"===e.name.value}))for(i=this.context.schema.getPossibleTypes(s),r=function(r){var a,o=i[r].getFields()[e];if(o&&(p=o,t&&t.arguments&&(a=t.arguments.every(function(e){return n(5)(o.args,function(t){return t.name===e.name.value})}))))return"break"},a=0;a<i.length&&(o=r(a),"break"!==o);a++);return p?new O(this.context,p):null},e.prototype.getInterfaces=function(){var t=this;return this.schemaUnmodifiedType instanceof x?this.schemaUnmodifiedType.getInterfaces().map(function(n){return new e(t.context,n)}):[]},e.prototype.getConcreteTypes=function(){var t=this;return n(3)(this.isAbstract(),"Cannot get concrete types of a concrete type."),this.context.schema.getPossibleTypes(this.schemaUnmodifiedType).map(function(n){return new e(t.context,n)})},e.prototype.getIdentifyingFieldDefinition=function(){return this.alwaysImplements("Node")?this.getFieldDefinition(p):null},e.prototype.isAbstract=function(){return D(this.schemaUnmodifiedType)},e.prototype.isList=function(){return this.isListType},e.prototype.isNonNull=function(){return this.isNonNullType},e.prototype.isQueryType=function(){return this.schemaUnmodifiedType===this.context.schema.getQueryType()},e.prototype.isConnection=function(){var e,t,n;return!!/Connection$/.test(this.getName({modifiers:!1}))&&(e=this.getFieldDefinition("edges"),!(!e||!e.getType().canHaveSubselections())&&(t=e.getType().getFieldDefinition("node"),!(!t||!t.getType().canHaveSubselections())&&(n=e.getType().getFieldDefinition("cursor"),!(!n||n.getType().canHaveSubselections()))))},e.prototype.isConnectionEdge=function(){return/Edge$/.test(this.getName({modifiers:!1}))&&this.hasField("node")&&this.hasField("cursor")},e.prototype.isConnectionPageInfo=function(){return"PageInfo"===this.getName({modifiers:!1})},e.prototype.alwaysImplements=function(e){return this.getName({modifiers:!1})===e||this.getInterfaces().some(function(t){return t.getName({modifiers:!1})===e})||this.isAbstract()&&this.getConcreteTypes().every(function(t){return t.alwaysImplements(e)})},e.prototype.mayImplement=function(e){return this.getName({modifiers:!1})===e||this.getInterfaces().some(function(t){return t.getName({modifiers:!1})===e})||this.isAbstract()&&this.getConcreteTypes().some(function(t){return t.alwaysImplements(e)})},e.prototype.generateField=function(e){var t={kind:"Field",name:{kind:"Name",value:e}};return new U(this.context,t,this)},e.prototype.generateIdFragment=function(){var e={kind:"Fragment",name:{kind:"Name",value:"IdFragment"},typeCondition:{kind:"NamedType",name:{value:"Node"}}};return new Q(this.context,e,this)},e}(),O=function(){function e(t,n){(0,l.default)(this,e),this.context=t,this.schemaFieldDef=n}return e.prototype.getName=function(){return this.schemaFieldDef.name},e.prototype.getType=function(){return new B(this.context,this.schemaFieldDef.type)},e.prototype.hasArgument=function(e){return this.schemaFieldDef.args.some(function(t){return t.name===e})},e.prototype.getArgument=function(e){var t=n(5)(this.schemaFieldDef.args,function(t){return t.name===e});return n(3)(t,"You tried to get an argument named `%s` on field `%s`, but no such argument exists on that field.",e,this.getName()),new Y(t.type)},e.prototype.getDeclaredArguments=function(){var e={};return this.schemaFieldDef.args.forEach(function(t){e[t.name]=new Y(t.type)}),e},e}(),Y=function(){function e(t){(0,l.default)(this,e);var n=r(t),i=n.isListType,a=n.isNonNullType,o=n.schemaUnmodifiedType;this.isListType=i,this.isNonNullType=a,this.schemaUnmodifiedArgType=o,this.schemaModifiedArgType=t}return e.prototype.getName=function(e){var t=e.modifiers;return t?this.schemaModifiedArgType.toString():this.schemaUnmodifiedArgType.toString()},e.prototype.ofType=function(){return n(3)(this.isList()||this.isNonNull(),"Can only get type of list or non-null type."),new e(this.schemaUnmodifiedArgType)},e.prototype.isCustomScalar=function(){return this.isScalar()&&!(this.schemaUnmodifiedArgType===d||this.schemaUnmodifiedArgType===g||this.schemaUnmodifiedArgType===y||this.schemaUnmodifiedArgType===b||this.schemaUnmodifiedArgType===E)},e.prototype.isBoolean=function(){return this.schemaUnmodifiedArgType===d},e.prototype.isEnum=function(){return this.schemaUnmodifiedArgType instanceof h},e.prototype.isID=function(){return this.schemaUnmodifiedArgType===y},e.prototype.isList=function(){return this.isListType},e.prototype.isNonNull=function(){return this.isNonNullType},e.prototype.isNumber=function(){return this.schemaUnmodifiedArgType===g||this.schemaUnmodifiedArgType===b},e.prototype.isObject=function(){return this.schemaUnmodifiedArgType instanceof v},e.prototype.isScalar=function(){return this.schemaUnmodifiedArgType instanceof L},e.prototype.isString=function(){return this.schemaUnmodifiedArgType===E},e}();e.exports={RelayQLArgument:j,RelayQLArgumentType:Y,RelayQLDefinition:_,RelayQLDirective:q,RelayQLField:U,RelayQLFieldDefinition:O,RelayQLFragment:Q,RelayQLFragmentSpread:C,RelayQLInlineFragment:G,RelayQLMutation:V,RelayQLNode:S,RelayQLQuery:P,RelayQLSubscription:M,RelayQLType:B}},function(e,t){"use strict";var n={ID:"id"};e.exports=n},function(e,t,n){"use strict";function i(e,t,i,a,o,s,u){try{var l=n(22)(t,u.opts||{});return l.transform(e,i,{documentName:a,propName:o,tagName:s,enableValidation:s!==r})}catch(c){return n(21)(e,c,i,u)}}var r="RelayQL_GENERATED";e.exports=i},function(e,t){e.exports=require("babel-runtime/helpers/extends")},function(e,t,n){"use strict";function i(e){return e&&e.__esModule?e:{"default":e}}var r=i(n(13)),a=i(n(6)),o=i(n(31)),s=i(n(8)),u=n(10),l=(u.RelayQLArgument,u.RelayQLArgumentType,u.RelayQLDefinition,u.RelayQLDirective,u.RelayQLField),c=u.RelayQLFragment,p=u.RelayQLFragmentSpread,f=u.RelayQLInlineFragment,d=u.RelayQLMutation,m=u.RelayQLQuery,h=u.RelayQLSubscription,g=(u.RelayQLType,n(11)),y=g.ID;e.exports=function(e,t){function i(e){return e.getType().mayImplement("Node")&&!e.getSelections().some(function(e){return e instanceof f&&"Node"===e.getFragment().getType().getName({modifiers:!1})})}function u(e,t){var i,r;if("node"===e.getName()&&(i=e.getDeclaredArguments(),r=(0,s.default)(i),!t.isQueryType()&&1===r.length&&r[0]===y))throw new(n(1))(n(2).format("You defined a `node(%s: %s)` field on type `%s`, but Relay requires the `node` field to be defined on the root type. See the Object Identification Guide: \nhttp://facebook.github.io/relay/docs/graphql-object-identification.html",y,r[0]&&i[r[0]].getName({modifiers:!0}),t.getName({modifiers:!1})),e.getLocation())}function g(e){var t,i=[e.findArgument("first"),e.findArgument("last"),e.findArgument("before"),e.findArgument("after")],r=i[0],a=i[1],o=i[2],s=i[3],u=!r||!a||r.isVariable()&&a.isVariable();if(!u)throw new(n(1))(n(2).format("Connection arguments `%s(first: <count>, last: <count>)` are not supported unless both are variables. Use `(first: <count>)`, `(last: <count>)`, or `(first: $<var>, last: $<var>)`.",e.getName()),e.getLocation());if(u=!r||!o||r.isVariable()&&o.isVariable(),!u)throw new(n(1))(n(2).format("Connection arguments `%s(before: <cursor>, first: <count>)` are not supported unless both are variables. Use `(first: <count>)`, `(after: <cursor>, first: <count>)`, `(before: <cursor>, last: <count>)`, or `(before: $<var>, first: $<var>)`.",e.getName()),e.getLocation());if(u=!a||!s||a.isVariable()&&s.isVariable(),!u)throw new(n(1))(n(2).format("Connection arguments `%s(after: <cursor>, last: <count>)` are not supported unless both are variables. Use `(last: <count>)`, `(before: <cursor>, last: <count>)`, `(after: <cursor>, first: <count>)`, or `(after: $<var>, last: $<var>)`.",e.getName()),e.getLocation());t=e.getType().getFieldDefinition(F.edges).getType().getFieldDefinition(F.node).getType(),S(e,function(i){var r,a,o;if(i.getName()===F.edges||i.getName()===F.pageInfo){if(r=e.isPattern()||e.hasArgument("find")||e.hasArgument("first")||e.hasArgument("last"),!r)throw new(n(1))(n(2).format("You supplied the `%s` field on a connection named `%s`, but you did not supply an argument necessary to do so. Use either the `find`, `first`, or `last` argument.",i.getName(),e.getName()),e.getLocation())}else if(a=i.getType(),o=a.isList()&&a.getName({modifiers:!1})===t.getName({modifiers:!1}))throw new(n(1))(n(2).format("You supplied a field named `%s` on a connection named `%s`, but pagination is not supported on connections without using `%s`. Use `%s{%s{%s{...}}}` instead.",i.getName(),e.getName(),F.edges,e.getName(),F.edges,F.node),e.getLocation())})}function v(e){var t,i=e.getDeclaredArguments(),r=(0,s.default)(i);if(1!==r.length)throw new(n(1))(n(2).format("Your schema defines a mutation field `%s` that takes %d arguments, but mutation fields must have exactly one argument named `%s`.",e.getName(),r.length,k),e.getLocation());if(r[0]!==k)throw new(n(1))(n(2).format("Your schema defines a mutation field `%s` that takes an argument named `%s`, but mutation fields must have exactly one argument named `%s`.",e.getName(),r[0],k),e.getLocation());if(t=e.getArguments(),t.length>1)throw new(n(1))(n(2).format("There are %d arguments supplied to the mutation field named `%s`, but mutation fields must have exactly one `%s` argument.",t.length,e.getName(),k),e.getLocation())}function b(t){var n=[];return(0,s.default)(t).forEach(function(e){var i=t[e];i!==I&&n.push(w(e,i))}),e.objectExpression(n)}function N(t){return t.split(".").reduce(function(t,n){return t?e.memberExpression(t,e.identifier(n)):e.identifier(n)},null)}function T(t){var n=[];return(0,s.default)(t).forEach(function(i){var r=t[i];r&&n.push(w(i,e.valueToNode(r)))}),e.objectExpression(n)}function w(t,n){return e.objectProperty(e.identifier(t),n)}function x(t){if(null==t)return I;if(Array.isArray(t))return e.arrayExpression(t.map(x));if("object"==typeof t&&null!=t){var n=t;return e.objectExpression((0,s.default)(n).map(function(e){return w(e,x(n[e]))}))}return e.valueToNode(t)}function L(t){return e.callExpression(e.memberExpression(e.memberExpression(D,e.identifier("concat")),e.identifier("apply")),[D,t])}function E(e){return n(5)(e.getDirectives(),function(e){return"relay"===e.getName()})}var A=t.snakeCase?function(e){var t={};return(0,s.default)(e).forEach(function(e){t[e]=e.replace(/[A-Z]/g,function(e){return"_"+e.toLowerCase()})}),t}:function(e){return e},D=e.arrayExpression([]),F=A({__typename:"__typename",clientMutationId:"clientMutationId",clientSubscriptionId:"clientSubscriptionId",cursor:"cursor",edges:"edges",hasNextPage:"hasNextPage",hasPreviousPage:"hasPreviousPage",node:"node",pageInfo:"pageInfo"}),k=t.inputArgumentName||"input",I=e.nullLiteral(),R=function(){function t(e,n){(0,a.default)(this,t),this.tagName=e,this.variableNames=n}return t.prototype.print=function(t,i){var r=!(arguments.length>2&&void 0!==arguments[2])||arguments[2],a=void 0;if(t instanceof m)a=this.printQuery(t,r);else if(t instanceof c)a=this.printFragment(t);else if(t instanceof d)a=this.printMutation(t,r);else{if(!(t instanceof h))throw new(n(1))(n(2).format("Unsupported definition: %s",t),t.getLocation());a=this.printSubscription(t,r)}return e.callExpression(e.functionExpression(null,i.map(function(t){return e.identifier(t.name)}),e.blockStatement([e.returnStatement(a)])),i.map(function(e){return e.value}))},t.prototype.printQuery=function(t,i){var r,a,o,s,u,l,c,p,f,d,m,h=t.getFields();if(1!==h.length&&i)throw new(n(1))(n(2).format("There are %d fields supplied to the query named `%s`, but queries must have exactly one field.",h.length,t.getName()),t.getLocation());if(r=h[0],a=r.getType(),o=r.getArguments(),s={},u=a.getIdentifyingFieldDefinition(),u&&(s[u.getName()]=!0),a.isAbstract()&&(s[F.__typename]=!0),l=this.printSelections(r,s),c={},a.isList()&&(c.isPlural=!0),a.isAbstract()&&(c.isAbstract=!0),o.length>1)throw new(n(1))(n(2).format("Invalid root field `%s`; Relay only supports root fields with zero or one argument.",r.getName()),t.getLocation());return p=I,1===o.length&&(f=o[0],d=f.getName(),m=f.getType().getName({modifiers:!0}),c.identifyingArgName=d,c.identifyingArgType=m,p=e.arrayExpression([b({kind:e.valueToNode("Call"),metadata:T({type:m}),name:e.valueToNode(d),value:this.printArgumentValue(f)})])),b({calls:p,children:l,directives:this.printDirectives(r.getDirectives()),fieldName:e.valueToNode(r.getName()),kind:e.valueToNode("Query"),metadata:T(c),name:e.valueToNode(t.getName()),type:e.valueToNode(a.getName({modifiers:!1}))})},t.prototype.printFragment=function(t){var r,a,o,s,u,l,c=this,p=t.getType(),f={},d=void 0;if(p.hasField(y)?f[y]=!0:i(t,p)&&(d=p.generateIdFragment()),p.isAbstract()&&(f[F.__typename]=!0),r=this.printSelections(t,f,d?[d]:null,t.hasDirective("generated")),a=E(t),o=a&&n(5)(a.getArguments(),function(e){return"variables"===e.getName()}),s=this.printRelayDirectiveMetadata(t,{isAbstract:p.isAbstract(),isTrackingEnabled:!!o}),u=b({children:r,directives:this.printDirectives(t.getDirectives()),id:this.printFragmentID(t),kind:e.valueToNode("Fragment"),metadata:s,name:e.valueToNode(t.getName()),type:e.valueToNode(p.getName({modifiers:!1}))}),o){if(l=o.getValue(),!Array.isArray(l))throw new(n(1))("The variables argument to the @relay directive should be an array of strings.",t.getLocation());return e.callExpression(e.memberExpression(N(this.tagName),e.identifier("__createFragment")),[u,e.objectExpression(l.map(function(e){var t=e.getValue();return w(t,c.printVariable(t))}))])}return u},t.prototype.printFragmentID=function(t){return e.callExpression(e.memberExpression(N(this.tagName),e.identifier("__id")),[])},t.prototype.printMutation=function(t,i){var r,a,o,s,u,l=t.getFields();if(1!==l.length&&i)throw new(n(1))(n(2).format("There are %d fields supplied to the mutation named `%s`, but mutations must have exactly one field.",l.length,t.getName()),t.getLocation());return r=l[0],a=r.getType(),v(r),o={},a.hasField(F.clientMutationId)&&(o[F.clientMutationId]=!0),s=this.printSelections(r,o),u={inputType:this.printArgumentTypeForMetadata(r.getDeclaredArgument(k))},b({calls:e.arrayExpression([b({kind:e.valueToNode("Call"),metadata:T({}),name:e.valueToNode(r.getName()),value:this.printVariable("input")})]),children:s,directives:this.printDirectives(t.getDirectives()),kind:e.valueToNode("Mutation"),metadata:T(u),name:e.valueToNode(t.getName()),responseType:e.valueToNode(a.getName({modifiers:!1}))})},t.prototype.printSubscription=function(t,i){var r,a,o,s,u,l=t.getFields();if(1!==l.length&&i)throw new(n(1))(n(2).format("There are %d fields supplied to the subscription named `%s`, but subscriptions must have exactly one field.",l.length,t.getName()),t.getLocation());return r=l[0],a=r.getType(),v(r),o={},a.hasField(F.clientSubscriptionId)&&(o[F.clientSubscriptionId]=!0),a.hasField(F.clientMutationId)&&(o[F.clientMutationId]=!0),s=this.printSelections(r,o),u={inputType:this.printArgumentTypeForMetadata(r.getDeclaredArgument(k))},b({calls:e.arrayExpression([b({kind:e.valueToNode("Call"),metadata:T({}),name:e.valueToNode(r.getName()),value:this.printVariable("input")})]),children:s,directives:this.printDirectives(t.getDirectives()),kind:e.valueToNode("Subscription"),metadata:T(u),name:e.valueToNode(t.getName()),responseType:e.valueToNode(a.getName({modifiers:!1}))})},t.prototype.printSelections=function(t,i,r){var a,s,u,c=this,d=arguments.length>3&&void 0!==arguments[3]&&arguments[3],m=[],h=[],g=!1;return t.getSelections().forEach(function(e){if(e instanceof p){if(0!==e.getDirectives().length)throw new(n(1))("Directives are not yet supported for `${fragment}`-style fragment references.",e.getLocation());h.push(c.printFragmentReference(e)),g=!0}else if(e instanceof f)h.push(c.printFragment(e.getFragment()));else{if(!(e instanceof l))throw new(n(1))(n(2).format("Unsupported selection type `%s`.",e),e.getLocation());m.push(e)}}),r&&r.forEach(function(e){h.push(c.printFragment(e))}),a=this.printFields(m,t,i,d),s=[].concat((0,o.default)(a),h),s.length?(u=e.arrayExpression(s),g?L(u):u):I},t.prototype.printFields=function(e,t,n){var i,a,o=this,u=arguments.length>3&&void 0!==arguments[3]&&arguments[3],l=t.getType();return l.isConnection()&&l.hasField(F.pageInfo)&&e.some(function(e){return e.getName()===F.edges})&&(n[F.pageInfo]=!0),i=(0,r.default)({},n),a=[],e.forEach(function(e){delete i[e.getName()],a.push(o.printField(e,t,n,i,u))}),(0,s.default)(i).forEach(function(e){var r=l.generateField(e);a.push(o.printField(r,t,n,i,u))}),a},t.prototype.printField=function(t,n,r,a){var o,s,l,c,p=this,f=arguments.length>4&&void 0!==arguments[4]&&arguments[4],d=t.getType(),m={},h={},v=void 0;return d.hasField(y)?h[y]=!0:i(t,d)&&(v=d.generateIdFragment()),f||u(t,n.getType()),d.canHaveSubselections()&&(m.canHaveSubselections=!0),d.alwaysImplements("Node")&&(m.inferredRootCallName="node",m.inferredPrimaryKey=y),d.isConnection()?(t.hasDeclaredArgument("first")||t.hasDeclaredArgument("last"))&&(f||g(t),m.isConnection=!0,t.hasDeclaredArgument("find")&&(m.isFindable=!0)):d.isConnectionPageInfo()?(h[F.hasNextPage]=!0,h[F.hasPreviousPage]=!0):d.isConnectionEdge()&&(h[F.cursor]=!0,h[F.node]=!0),d.isAbstract()&&(m.isAbstract=!0,h[F.__typename]=!0),d.isList()&&(m.isPlural=!0),a.hasOwnProperty(t.getName())&&(m.isGenerated=!0),r.hasOwnProperty(t.getName())&&(m.isRequisite=!0),o=this.printSelections(t,h,v?[v]:null,f),s=t.getAlias(),l=t.getArguments(),c=l.length?e.arrayExpression(l.map(function(e){return p.printArgument(e)})):I,b({alias:s?e.valueToNode(s):I,calls:c,children:o,directives:this.printDirectives(t.getDirectives()),fieldName:e.valueToNode(t.getName()),kind:e.valueToNode("Field"),metadata:this.printRelayDirectiveMetadata(t,m),type:e.valueToNode(d.getName({modifiers:!1}))})},t.prototype.printFragmentReference=function(t){return e.callExpression(e.memberExpression(N(this.tagName),e.identifier("__frag")),[e.identifier(t.getName())])},t.prototype.printArgument=function(t){var n={},i=this.printArgumentTypeForMetadata(t.getType());return i&&(n.type=i),b({kind:e.valueToNode("Call"),metadata:T(n),name:e.valueToNode(t.getName()),value:this.printArgumentValue(t)})},t.prototype.printArgumentValue=function(e){return e.isVariable()?this.printVariable(e.getVariableName()):this.printValue(e.getValue())},t.prototype.printVariable=function(t){return this.variableNames.hasOwnProperty(t)?e.callExpression(e.memberExpression(N(this.tagName),e.identifier("__var")),[e.identifier(t)]):b({kind:e.valueToNode("CallVariable"),callVariableName:e.valueToNode(t)})},t.prototype.printValue=function(t){var n=this;return Array.isArray(t)?e.arrayExpression(t.map(function(e){return n.printArgumentValue(e)})):b({kind:e.valueToNode("CallValue"),callValue:null==t?e.nullLiteral():x(t)})},t.prototype.printDirectives=function(t){var n=this,i=[];return t.forEach(function(t){"relay"!==t.getName()&&i.push(e.objectExpression([w("kind",e.valueToNode("Directive")),w("name",e.valueToNode(t.getName())),w("args",e.arrayExpression(t.getArguments().map(function(t){return e.objectExpression([w("name",e.valueToNode(t.getName())),w("value",n.printArgumentValue(t))])})))]))}),i.length?e.arrayExpression(i):I},t.prototype.printRelayDirectiveMetadata=function(t,i){var r,a=[],o=E(t);return o&&o.getArguments().forEach(function(i){if(i.isVariable())throw new(n(1))(n(2).format("You supplied `$%s` as the `%s` argument to the `@relay` directive, but `@relay` require scalar argument values.",i.getVariableName(),i.getName()),t.getLocation());"variables"!==i.getName()&&a.push(w(i.getName(),e.valueToNode(i.getValue())))}),i&&(r=i,(0,s.default)(r).forEach(function(t){r[t]&&a.push(w(t,e.valueToNode(r[t])))})),e.objectExpression(a)},t.prototype.printArgumentTypeForMetadata=function(e){return e.isBoolean()||e.isID()||e.isString()?null:e.getName({modifiers:!0})},t}(),S=function _(e,t){e.getSelections().forEach(function(e){e instanceof l?t(e):e instanceof f&&_(e.getFragment(),t)})};return R}},function(e,t,n){"use strict";function i(e){return e&&e.__esModule?e:{"default":e}}function r(e){return e[0].toUpperCase()+e.slice(1)}function a(){var e=0;return function(){return(e++).toString(32)}}var o=i(n(6)),s=n(10),u=(s.RelayQLDefinition,s.RelayQLFragment),l=s.RelayQLMutation,c=s.RelayQLQuery,p=s.RelayQLSubscription,f=n(4),d=f.formatError,m=f.parse,h=f.Source,g=f.validate,y=f.ArgumentsOfCorrectTypeRule,v=f.DefaultValuesOfCorrectTypeRule,b=f.FieldsOnCorrectTypeRule,N=f.FragmentsOnCompositeTypesRule,T=f.KnownArgumentNamesRule,w=f.KnownTypeNamesRule,x=f.PossibleFragmentSpreadsRule,L=f.VariablesInAllowedPositionRule,E=f.ProvidedNonNullArgumentsRule,A=function(){
function e(t,n){(0,o.default)(this,e),this.schema=t,this.options=n}return e.prototype.transform=function(e,t,i){var r=this.processTemplateLiteral(t,i.documentName),a=r.substitutions,o=r.templateText,s=r.variableNames,u=this.processTemplateText(o,i),l=this.processDocumentText(u,i),c=n(14)(e,this.options);return new c(i.tagName,s).print(l,a,i.enableValidation)},e.prototype.processTemplateLiteral=function(e,t){var i=this,r=[],a={},o=[];return e.quasis.forEach(function(s,u){var l,c,p=s.value.cooked;r.push(p),s.tail||(l="RQL_"+u,c=e.expressions[u],o.push({name:l,value:c}),/:\s*$/.test(p)?(n(3)(i.options.substituteVariables,"You supplied a GraphQL document named `%s` that uses template substitution for an argument value, but variable substitution has not been enabled.",t),r.push("$"+l),a[l]=void 0):r.push("..."+l))}),{substitutions:o,templateText:r.join("").trim(),variableNames:a}},e.prototype.processTemplateText=function(e,t){var i,a,o,s,u=t.documentName,l=t.propName,c=/^(fragment|mutation|query|subscription)\s*(\w*)?([\s\S]*)/,p=c.exec(e);return n(3)(p,"You supplied a GraphQL document named `%s` with invalid syntax. It must start with `fragment`, `mutation`, `query`, or `subscription`.",u),i=p[1],a=p[2]||u,o=p[3],"fragment"===i&&"on"===a&&(a=u+(l?"_"+r(l):"")+"RelayQL",o="on"+o),s=r(a),i+" "+s+" "+o},e.prototype.processDocumentText=function(e,t){var i,o,s,f=t.documentName,d=t.enableValidation,g=m(new h(e,f)),y=d?this.validateDocument(g,f):null;if(y)throw i=new Error(n(2).format("You supplied a GraphQL document named `%s` with validation errors.",f)),i.validationErrors=y,i.sourceText=e,i;if(o=g.definitions[0],s={definitionName:r(f),isPattern:!1,generateID:a(),schema:this.schema},"FragmentDefinition"===o.kind)return new u(s,o);if("OperationDefinition"===o.kind){if("mutation"===o.operation)return new l(s,o);if("query"===o.operation)return new c(s,o);if("subscription"===o.operation)return new p(s,o);n(3)(!1,"Unsupported operation: %s",o.operation)}else n(3)(!1,"Unsupported definition kind: %s",o.kind)},e.prototype.validateDocument=function(e,t){var i,r,a,o,s;return n(3)(1===e.definitions.length,"You supplied a GraphQL document named `%s` with %d definitions, but it must have exactly one definition.",t,e.definitions.length),i=e.definitions[0],r="OperationDefinition"===i.kind&&"mutation"===i.operation,a=this.options.validator,o=void 0,a?o=a().validate(this.schema,e):(s=[y,v,b,N,T,w,x,L],r||s.push(E),o=g(this.schema,e,s)),o&&o.length>0?o.map(d):null},e}();e.exports=A},function(e,t,n){"use strict";function i(e){return e&&e.__esModule?e:{"default":e}}function r(e,t,i,r){var l,c,p,f,d,m,h,g,y,v,b=r.definitions[0];if("FragmentDefinition"===b.kind){if(l=u(e,t)){if(1!==r.definitions.length)throw new Error("BabelPluginRelay: Expected exactly one fragment in the "+("graphql tag referenced by the property "+l+"."));return o(e,t,a(e,i,t,b))}c={},p=!0,f=!1,d=void 0;try{for(m=r.definitions[Symbol.iterator]();!(p=(h=m.next()).done);p=!0){if(g=h.value,"FragmentDefinition"!==g.kind)throw new Error("BabelPluginRelay: Expected only fragments within this graphql tag.");y=n(7)(g.name.value),v=y[1],c[v]=a(e,i,t,g)}}catch(N){f=!0,d=N}finally{try{!p&&m.return&&m.return()}finally{if(f)throw d}}return o(e,t,s(e,c))}if("OperationDefinition"===b.kind){if(1!==r.definitions.length)throw new Error("BabelPluginRelay: Expected exactly one operation (query, mutation, or subscription) per graphql tag.");return o(e,t,a(e,i,t,b))}throw new Error("BabelPluginRelay: Expected a fragment, mutation, query, or subscription, got `"+b.kind+"`.")}function a(e,t,i,r){var a=Boolean(t.opts&&t.opts.compat),o=Boolean(t.opts&&t.opts.haste),s=n(20)(e,r,o);return a?n(19)(e,s,n(18)(e,i,r,t)):s}function o(e,t,n){for(var i,r=t.scope;r.parent;)r=r.parent;t.scope===r?t.replaceWith(n):(i=r.generateDeclaredUidIdentifier("graphql"),t.replaceWith(e.logicalExpression("||",i,e.assignmentExpression("=",i,n))))}function s(e,t){return e.objectExpression((0,l.default)(t).map(function(n){return e.objectProperty(e.identifier(n),t[n])}))}function u(e,t){for(var n=t;n;){if(e.isObjectProperty(n)&&n.node.key.name)return n.node.key.name;n=n.parentPath}}var l=i(n(8));e.exports=r},function(e,t){"use strict";function n(e){var t,n,i,r=e.start,a=(e.end,e.source);if(!a)return null;for(t=a.body.split("\n"),n=0,i=0;i<t.length&&!(t[i].length+n>=r);i++)n+=t[i].length+1;return{line:i+1,column:r-n+1,source:t[i]}}e.exports=n},function(e,t,n){"use strict";function i(e){return e&&e.__esModule?e:{"default":e}}function r(e,t,n,i){if("FragmentDefinition"===n.kind)return a(e,t,n,i);if("OperationDefinition"===n.kind)return o(e,t,n,i);throw new Error("BabelPluginRelay: Expected a fragment, mutation, query, or subscription, got `"+n.kind+"`.")}function a(e,t,n,i){var r=s(e,n),a=r.classicAST,o=r.fragments,l=r.variables,p=r.argumentDefinitions,f=b(e,t,o),d=h(e,{kind:e.stringLiteral("FragmentDefinition"),argumentDefinitions:c(e,p,l),node:v(e,a,i)});return u(e,d,f,i)}function o(e,t,n,i){var r=s(e,n),a=r.classicAST,o=r.fragments,c=b(e,t,o),p="query"===a.operation?y(e,a,i):v(e,a,i),f=h(e,{kind:e.stringLiteral("OperationDefinition"),argumentDefinitions:l(e,n.variableDefinitions),name:e.stringLiteral(n.name.value),operation:e.stringLiteral(a.operation),node:p});return u(e,f,c,i)}function s(e,t){var i=0,r={},a={},o=null,s={Directive:function(e){switch(e.name.value){case"argumentDefinitions":if(o)throw new Error("BabelPluginRelay: Expected only one @argumentDefinitions directive");return o=e.arguments,null;case"connection":return null;default:return e}},FragmentSpread:function(t){var n,a,o=t.directives,s=t.name.value,u=null,l=null;if(0===o.length)l=s;else{if(n=o[0],1!==o.length||"arguments"!==n.name.value)throw new Error("BabelPluginRelay: Unsupported directive `"+n.name.value+"` on fragment spread `..."+s+"`.");a={},n.arguments.forEach(function(t){var n=m(e,t);a[n.name]=n.ast}),u=h(e,a),i++,l=s+"_args"+i}return r[l]={name:s,args:u},(0,x.default)({},t,{name:{kind:"Name",value:l},directives:[]})},Variable:function(e){return a[e.name.value]=null,e}},u=n(4).visit(t,s);return{classicAST:u,fragments:r,variables:a,argumentDefinitions:o}}function u(e,t,n,i){var r=i.opts&&i.opts.relayQLModule,a=r?g(e,r):e.memberExpression(g(e,"react-relay/classic"),e.identifier("QL"));return e.functionExpression(null,[],e.blockStatement([e.variableDeclaration("const",[e.variableDeclarator(e.identifier(L),a)].concat(n)),e.returnStatement(t)]))}function l(e,t){return e.arrayExpression(t.map(function(t){var n=t.variable.name.value,i=t.defaultValue?d(e,t.defaultValue):e.nullLiteral();return p(e,n,i)}))}function c(e,t,n){var i=[];return(0,w.default)(n).forEach(function(n){var r,a,o=(t||[]).find(function(e){return e.name.value===n});o?(r=o.value.fields.find(function(e){return"defaultValue"===e.name.value}),a=r?d(e,r.value):e.nullLiteral(),i.push(p(e,n,a))):i.push(f(e,n))}),e.arrayExpression(i)}function p(e,t,n){return h(e,{defaultValue:n,kind:e.stringLiteral("LocalArgument"),name:e.stringLiteral(t)})}function f(e,t){return e.objectExpression([e.objectProperty(e.identifier("kind"),e.stringLiteral("RootArgument")),e.objectProperty(e.identifier("name"),e.stringLiteral(t))])}function d(e,t){switch(t.kind){case"BooleanValue":return e.booleanLiteral(t.value);case"IntValue":return e.numericLiteral(parseInt(t.value,10));case"FloatValue":return e.numericLiteral(parseFloat(t.value));case"StringValue":return e.stringLiteral(t.value);case"EnumValue":return e.stringLiteral(t.value);case"ListValue":return e.arrayExpression(t.values.map(function(t){return d(e,t)}));default:throw new Error("BabelPluginRelay: Unsupported literal type `"+t.kind+"`.")}}function m(e,t){var n,i=t.name.value,r=t.value,a=null;switch(r.kind){case"Variable":n=r.name.value,a=h(e,{kind:e.stringLiteral("CallVariable"),callVariableName:e.stringLiteral(n)});break;default:a=d(e,r)}return{name:i,ast:a}}function h(e,t){return e.objectExpression((0,w.default)(t).map(function(n){return e.objectProperty(e.identifier(n),t[n])}))}function g(e,t){return e.callExpression(e.identifier("require"),[e.stringLiteral(t)])}function y(e,t,n){var i,r=void 0;switch(t.operation){case"query":r="Query";break;case"mutation":r="Mutation";break;case"subscription":r="Subscription";break;default:throw new Error("BabelPluginRelay: Unexpected operation type: `"+t.operation+"`.")}return i={kind:"FragmentDefinition",loc:t.loc,name:{kind:"Name",value:t.name.value},typeCondition:{kind:"NamedType",name:{kind:"Name",value:r}},directives:t.directives,selectionSet:t.selectionSet},v(e,i,n)}function v(e,t,i){var r,a,o,s,u,l=i.opts&&i.opts.schema;return n(3)(l,'babel-plugin-relay: Missing schema option. Check your .babelrc file or wherever you configure your Babel plugins to ensure the "relay" plugin has a "schema" option.\nhttps://facebook.github.io/relay/docs/babel-plugin-relay.html#additional-options'),r=n(7)(t.name.value),a=r[0],o=r[1],s=n(4).print(t),u=e.templateLiteral([e.templateElement({raw:s,cooked:s},!0)],[]),n(12)(e,l,u,a,o,L,i)}function b(e,t,i){return(0,w.default)(i).map(function(r){var a=i[r],o=n(7)(a.name),s=o[0],u=o[1];return e.variableDeclarator(e.identifier(r),N(e,t,s,u,a.args))})}function N(e,t,n,i,r){var a,o=[];return i&&o.push(e.stringLiteral(i)),r&&o.push(r),a=T(t,n)?e.logicalExpression("||",e.memberExpression(e.identifier(n),e.identifier("__container__")),e.identifier(n)):e.identifier(n),e.callExpression(e.memberExpression(a,e.identifier("getFragment")),o)}function T(e,t){var n=e.scope.getBinding(t);return!!n&&("module"!==n.kind&&!(n.path.isVariableDeclarator()&&n.path.get("init").node&&n.path.get("init.callee").isIdentifier({name:"require"})))}var w=i(n(8)),x=i(n(28)),L="RelayQL_GENERATED";e.exports=r},function(e,t){"use strict";function n(e,t,n){return e.objectExpression([e.objectProperty(e.identifier("modern"),t),e.objectProperty(e.identifier("classic"),n)])}e.exports=n},function(e,t){"use strict";function n(e,t,n){var r=t.name.value+".graphql",a=n?r:i+r;return e.functionExpression(null,[],e.blockStatement([e.returnStatement(e.callExpression(e.identifier("require"),[e.stringLiteral(a)]))]))}var i="./__generated__/";e.exports=n},function(e,t,n){"use strict";function i(e,t,i,r){var a,o,s,u,l,c,p,f=r.opts||{},d=(f.suppressWarnings?function(){}:console.warn.bind(console),r.file.opts.basename||"UnknownFile",r.file.opts.filename||"UnknownFile"),m=[];if(t instanceof n(1)?(m.push(t.message),a=i.loc&&i.loc.start.line,o=t.loc&&n(17)(t.loc)):(s=t.sourceText,u=t.validationErrors,l=!(!u||!s),l?(c=s.split("\n"),u.forEach(function(e){var t=e.message,n=e.locations;m.push(t),n.forEach(function(e){c[e.line-1]})})):m.push(t.message)),p=n(2).format("%s error ``%s`` in file `%s`. Try updating your GraphQL schema if an argument/field/type was recently added.",l?"GraphQL validation":"Relay transform",m.join(" "),d),f.enforceSchema)throw new Error(n(2).format(m.length?"Aborting due to a %s error:\n\n%s\n":"Aborting due to %s errors:\n\n%s\n",l?"GraphQL validation":"Relay transform",m.map(function(e){return"  - "+e}).join("\n")));return f.debug&&console.error(t.stack),e.callExpression(e.functionExpression(null,[],e.blockStatement([e.throwStatement(e.newExpression(e.identifier("Error"),[e.valueToNode(p)]))])),[])}e.exports=i},function(e,t,n){"use strict";function i(e){return e&&e.__esModule?e:{"default":e}}function r(e,t){var i,r=c.get(e);return r||(i=a(e),r=new(n(15))(i,{inputArgumentName:t.inputArgumentName,snakeCase:Boolean(t.snakeCase),substituteVariables:Boolean(t.substituteVariables),validator:t.validator}),c.set(e,r)),r}function a(e){var t="function"==typeof e?e():e,i="string"==typeof t?n(24)(t):t;if(i.__schema)return l(i);if(i.data&&i.data.__schema)return l(i.data);if(i.kind&&"Document"===i.kind)return u(i);throw new Error("Invalid introspection data supplied to `getBabelRelayPlugin()`. The resulting schema is not an object with a `__schema` property or a schema IDL language.")}var o=i(n(27)),s=n(4),u=s.buildASTSchema,l=s.buildClientSchema,c=new o.default;e.exports=r},function(e,t){"use strict";function n(e,t){for(var n,r,a,o,s,u,l,c,p,f=e;f.parentPath;)f=f.parentPath;if(n=f.documentName,!n){if(r=f.parent,r.comments&&r.comments.length)for(a=r.comments[0].value||"",o=/@(\S+) *(\S*)/g,s=void 0;s=o.exec(a);)if(u=s[1],l=s[2],u===i){n=l.replace(/[\.-:]/g,"_");break}c=t.file.opts.basename,c&&!n&&(p=c.match(/^[_A-Za-z][_0-9A-Za-z]*/),p&&(n=p[0])),n=n||"UnknownFile",f.documentName=n}return n}var i="providesModule";e.exports=n},function(e,t,n){"use strict";function i(e){try{var t=n(32).readFileSync(e,"utf8");return"{"===t[0]?JSON.parse(t):a(o+"\n"+t)}catch(i){throw console.error("Encountered the following error while loading the GraphQL schema: "+e+"\n\n"+i.stack.split("\n").map(function(e){return"> "+e}).join("\n")),i}}var r=n(4),a=r.parse,o="\n  directive @include(if: Boolean) on FRAGMENT_DEFINITION | FRAGMENT_SPREAD | INLINE_FRAGMENT | FIELD\n  directive @skip(if: Boolean) on FRAGMENT_DEFINITION | FRAGMENT_SPREAD | INLINE_FRAGMENT | FIELD\n  directive @relay(\n    isConnectionWithoutNodeID: Boolean,\n    pattern: Boolean,\n    plural: Boolean,\n    variables: [String],\n  ) on FRAGMENT_DEFINITION | FRAGMENT_SPREAD | INLINE_FRAGMENT | FIELD\n  directive @generated on OPERATION | FRAGMENT_DEFINITION | FRAGMENT_SPREAD | INLINE_FRAGMENT\n";e.exports=i},function(e,t,n){"use strict";function i(e){var t,i,r,a=e.get("tag"),o=a.isIdentifier({name:"graphql"})?"graphql":a.matchesPattern("graphql.experimental")?"graphql.experimental":void 0;if(o){if(t=e.node.quasi.quasis,1!==t.length)throw new Error("BabelPluginRelay: Substitutions are not allowed in graphql fragments. Included fragments should be referenced as `...MyModule_propName`.");if(i=t[0].value.raw,"graphql"===o&&/@argument(Definition)?s\b/.test(i))throw new Error("BabelPluginRelay: Unexpected use of fragment variables: @arguments and @argumentDefinitions are only supported in experimental mode. Source: "+i);if(r=n(4).parse(i),0===r.definitions.length)throw new Error("BabelPluginRelay: Unexpected empty graphql tag.");return r}}e.exports=i},function(e,t){"use strict";function n(e){var t,n,r=e.node,a=e.get("tag"),o=a.matchesPattern("Relay.QL")?"Relay.QL":a.isIdentifier({name:"RelayQL"})?"RelayQL":a.isIdentifier({name:i})?i:null;if(!o)return[];for(t=e,n=null;!n&&(t=t.parentPath);)t.isProperty()&&(n=t.node.key.name);return[r.quasi,o,n]}var i="RelayQL_GENERATED";e.exports=n},function(e,t){e.exports=require("babel-runtime/core-js/map")},function(e,t){e.exports=require("babel-runtime/core-js/object/assign")},function(e,t){e.exports=require("babel-runtime/helpers/inherits")},function(e,t){e.exports=require("babel-runtime/helpers/possibleConstructorReturn")},function(e,t){e.exports=require("babel-runtime/helpers/toConsumableArray")},function(e,t){e.exports=require("fs")}]);